package com.example.a8_bitinvader;

import java.util.LinkedList;
import java.util.Queue;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;


public class Player extends Sprite{
    public class Bullet{
        private final int  speed = 5;  //this can be changed ltr;
        private final int X;
        private int Y;
        public Bullet(int xx, int yy){
            X = xx;
            Y = yy;
        }
        public void goUp(){
            Y += speed;
        }
        public int[] getLocation() {
            return new int[]{X, Y};
        }
    }

    private int health = 3;
    public Bitmap playerImg;
    private Queue<Bullet> Bullets = new LinkedList<>(); // max on the screen at the same time, can be change ltr;

    public Player(Resources res) {
        super(0,0);
        xPos = screenWidth/2;  //haven't implement it yet
        yPos = 9 * screenHeight/10; //haven't implement it yet
        playerImg = BitmapFactory.decodeResource(res, R.drawable.green64);
        playerImg = Bitmap.createScaledBitmap(playerImg, getWidth(), getHeight(), false);

    }

    //get input from the joystick, and change the location

    // tbh I think this is goingto give us an error ltr, becuase we are going to call update and shoot constantly, I wonder what will happen if we write and deleting at the same time. We'll see tho
    public void update(int joyStickInputX, int joyStickInputY){
        xPos += joyStickInputX;
        yPos += joyStickInputY;
        for(Bullet ii : Bullets) {
            ii.goUp();
        }
    }

    @Override //the return doesn't really mean anything all we need is that when any of the point hit within the hit box of player, call the loose health function.
    public boolean touching(int xx, int yy)
    {
        if( super.touching(xx,yy) ) {
            looseHealth();
            return true;
        } else {
            return false;
        }
    }

    // when looseHealth drop the help to 0, call the destroy function. which we will override ltr
    public void looseHealth() {
        health -= 1;
        if (health == 0) {
            destroy();
        }
    }


    public void shoot() {
        Bullets.add(new Bullet(xPos,yPos));
        if(Bullets.size() == 5){
            Bullets.remove();   // this should remove the first one that go into the list. it is a Que, so first in first out.
        }
    }

    @Override
    public void destroy() {
        //call animation also.
        //this should call the pulse function for the game, and manu would pop up.
        //implement ltr
    }

}
