package com.example.a8_bitinvader;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

public class Sprite {

    // public fields
    // xPos and yPos are represent top left corner of Sprite hit box
    // image is the Bitmap of the Sprite object
    int xPos, yPos;
    int screenWidth, screenHeight;
    Bitmap image;

    //private properties
    //FIXME THIS FORMULA IS WRONG, ONLY RETURNS 0
    private final int height = 128;//displayMetrics.heightPixels/100;
    private final int width = 128;//displayMetrics.widthPixels/100;

    //private properties

    /**
     * @param xPos
     * @param yPos
     */
    public Sprite(int xPos, int yPos)
    {
        this.xPos = xPos;
        this.yPos = yPos;
    }

    /**
     *
     * @return Height of the sprite
     */
    public int getHeight()
    {
        return height;
    }

    /**
     *
     * @return Width of the sprite
     */
    public int getWidth()
    {
        return width;
    }

    /**
     *
     * @param xx
     * @param yy
     * @return True if xx and yy are in the current sprite
     */
    public boolean touching(int xx, int yy)
    {
        //implement
        if((xx < (xPos+width) && xx > xPos) && (yy < (yPos+height) && yy > yPos))
        {
            return true;
        }
        return false;
    }

    public void destroy() {
        //this should call the animation, and delete the object
    }

    void updateLocation() {}    //other classes will override this function

}
